/* "pma_sam" utility:  invokes pma_set_avail_mem()

   Copyright (C) 2022  Terence Kelly
   Contact:  tpkelly @ { acm.org, cs.princeton.edu, eecs.umich.edu }
   Home:     http://web.eecs.umich.edu/~tpkelly/pma/  [or "https"]
   Design:   HTML:  https://queue.acm.org/detail.cfm?id=3534855
             PDF:   https://dl.acm.org/doi/pdf/10.1145/3534855

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU Affero General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU Affero General Public License for more details.

   You should have received a copy of the GNU Affero General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#include <assert.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "pma.h"

#define S(s) #s
#define S2(s) S(s)
#define COORDS __FILE__ ":" S2(__LINE__) ": "
#define FP(...) (void)fprintf(stderr, __VA_ARGS__)

int main(int argc, char *argv[]) {
  int r;
  if (2 != argc) {
    FP("usage:  %s  heapfile\n", argv[0]);
    return 1;
  }
  if (0 != (r = pma_init(2, argv[1]))) {
    FP(COORDS "pma_init returned %d on '%s': pma_errno == %d\n",
                                 r,     argv[1],          pma_errno);
    return 2;
  }
  pma_set_avail_mem(0UL);
  return 0;
}

